package org.kmeans.bisec;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;
import java.util.TreeMap;

/**
 * Coded by Luciano Giuseppe
 * each row of the features vector is hashmap where the key is the name of the
 * word and the value a inverse frequency of it
 * 
 */

public class Document {

	private String name = "centroid";
	private Integer numOfDocs = 0;
	private HashMap<String, Double> words = new HashMap<String, Double>();

	public Document() {

	}

	// in the centroid no take the column 0
	public Document(String line, int what) {
		// separate for coloumn
		String[] columns = line.split(";");

		// the name of the document
		if (what == 1)
			this.name = "centroid";
		if (what == 2)
			this.name = columns[0];

		for (int i = 1; i < columns.length; i++) {
			// separate key and value
			String[] keyAndValue = columns[i].split(":");

			try {
				if (keyAndValue.length == 1) {
					System.out.println(columns[i]);
					throw new Exception("e");
				}
				this.words.put(keyAndValue[0],
						Double.parseDouble(keyAndValue[1]));
			} catch (Exception e) {
				e.printStackTrace();
			}

		}

		this.numOfDocs++;
	}

	public int getSize() {
		return this.numOfDocs;
	}

	public String getName() {
		return name;
	}

	public HashMap<String, Double> getMap() {
		return words;
	}

	public String toString() {

		StringBuilder toReturn = new StringBuilder();

		toReturn.append(name);

		for (Entry<String, Double> entry : words.entrySet()) {
			toReturn.append(entry.getKey() + ":" + entry.getValue());
		}

		return toReturn.toString();
	}

	public void normalize() {
		Iterator<Entry<String, Double>> iter = this.words.entrySet().iterator();
		while (iter.hasNext()) {
			Entry<String, Double> t = iter.next();
			// mean computation for this word
			double valore = t.getValue() / this.numOfDocs;
			t.setValue(valore);
		}

		
	}

	
	public void mergeDocument(Document d1) {

		// foreach word
		Iterator<Entry<String, Double>> iter = d1.getMap().entrySet()
				.iterator();
		double value;

		while (iter.hasNext()) {

			Entry<String, Double> t = iter.next();
			//get the key

			value = t.getValue();
			// JSE < 7
			/*Double t2 = 0.0;
			if(this.words.containsKey(t.getKey())) {
				t2 = (double) this.words.get(t.getKey());
			} */
			
			Double t2 = (double) this.words.getOrDefault(t.getKey(), 0.0); // gse
																			// non

			// aggiungo al centroide la parola, o cambio il valore

			value += t2;
			this.words.put(t.getKey(), value);
		}

		this.numOfDocs++;

		return;
	}

	public HashMap<String, Double> getWords() {
		return this.words;
	}

	public Integer getNumOfDocs() {
		return this.numOfDocs;
	}

}
